// DXImage.h: interface for the CDXImage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DXIMAGE_H__F4721AE3_5ADC_11D3_BB14_0080C81F9D2D__INCLUDED_)
#define AFX_DXIMAGE_H__F4721AE3_5ADC_11D3_BB14_0080C81F9D2D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDXImage : public CObject  
{
	DECLARE_DYNAMIC (CDXImage);

public:
	CDXImage ();
	virtual ~CDXImage ();

	//  
	virtual BOOL Create (LPDIRECTDRAW2 lpDD, UINT cx, UINT cy);

	//    
	virtual BOOL LoadFile (LPDIRECTDRAW2 lpDD, LPCTSTR szName);
	virtual BOOL LoadResource (LPDIRECTDRAW2 lpDD, LPCTSTR szName);
	
	//  
	virtual void Destroy (void);

	//    .   
	virtual BOOL Fill (COLORREF color = RGB (0, 0, 0));

	//        
	virtual BOOL FastDraw (LPDIRECTDRAWSURFACE3 lpDDDestSurface,
		CRect rect, int x = 0, int y = 0,
		DWORD dwFlags = DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
	virtual BOOL Draw (LPDIRECTDRAWSURFACE3 lpDDDestSurface,
		CRect rect, int x = 0, int y = 0,
		DWORD dwFlags = DDBLT_WAIT | DDBLT_KEYSRC, LPDDBLTFX lpDDBltFx = NULL);

	//   
	virtual int GetWidth (void) {return bm.bmWidth;};
	virtual int GetHeight (void) {return bm.bmHeight;};

	virtual LPDIRECTDRAWSURFACE3 GetSurface3 (void) {return m_lpDDSurface3;};
	virtual HDC GetDC (void);
	virtual BOOL ReleaseDC (HDC hdc);

protected:
	LPDIRECTDRAWSURFACE3 m_lpDDSurface3;	//  
    BITMAP bm;								//   
	LPDIRECTDRAW2 m_lpDD;					//   DirectDraw
	LPCTSTR m_szBitmap;						// ID    
	CRITICAL_SECTION m_cs;					//  
	int m_LoadType;							//   ?

	//     ( )
	virtual BOOL Reload (void);
	virtual BOOL LoadHelper (LPDIRECTDRAW2 lpDD, LPCTSTR szBitmap, BOOL bResource);
	virtual BOOL LoadFromHandle (LPDIRECTDRAW2 lpDD, HBITMAP hbm);

	virtual DWORD ColorMatch (COLORREF rgb);	//  

	//    (CLR_INVALID -   0,0)
	virtual BOOL SetColorKey (COLORREF rgb = CLR_INVALID);	//  

	void DestroyHelper (void);	//  
};

#endif // !defined(AFX_DXIMAGE_H__F4721AE3_5ADC_11D3_BB14_0080C81F9D2D__INCLUDED_)
