// DXMisc.cpp: implementation of the CDCDXImage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DXMisc.h"

#ifdef _DEBUG

#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW

void debugDXReportErrorFn (LPCTSTR title, HRESULT ddrval, LPCTSTR file, DWORD line)
{
	CString msg;
	msg.Format (_T("%s(%lu) : %s = "), file, line, title);
	switch (ddrval)
	{
		case DD_OK:
			msg += _T ("DD_OK The request completed successfully.\n");
			break;
		case DDERR_EXCLUSIVEMODEALREADYSET:
			msg += _T ("DDERR_EXCLUSIVEMODEALREADYSET\n");
			break;
		case DDERR_GENERIC:
			msg += _T ("DDERR_GENERIC An undetermined error occurred inside the DirectDraw subsystem.\n");
			break;
		case DDERR_HWNDALREADYSET:
			msg += _T ("DDERR_HWNDALREADYSET\n");
			break;
		case DDERR_HWNDSUBCLASSED:
			msg += _T ("DDERR_HWNDSUBCLASSED\n");
			break;
		case DDERR_IMPLICITLYCREATED:
			msg += _T ("DDERR_IMPLICITLYCREATED\n");
			break;
		case DDERR_INCOMPATIBLEPRIMARY:
			msg += _T ("DDERR_INCOMPATIBLEPRIMARY\n");
			break;
		case DDERR_INVALIDCAPS:
			msg += _T ("DDERR_INVALIDCAPS\n");
			break;
		case DDERR_INVALIDCLIPLIST:
			msg += _T ("DDERR_INVALIDCLIPLIST\n");
			break;
		case DDERR_INVALIDOBJECT:
			msg += _T ("DDERR_INVALIDOBJECT\n");
			break;
		case DDERR_INVALIDPARAMS:
			msg += _T ("DDERR_INVALIDPARAMS\n");
			break;
		case DDERR_INVALIDPIXELFORMAT:
			msg += _T ("DDERR_INVALIDPIXELFORMAT\n");
			break;
		case DDERR_INVALIDRECT:
			msg += _T ("DDERR_INVALIDRECT\n");
			break;
		case DDERR_NOALPHAHW:
			msg += _T ("DDERR_NOALPHAHW\n");
			break;
		case DDERR_NOBLTHW:
			msg += _T ("DDERR_NOBLTHW\n");
			break;
		case DDERR_NOCLIPLIST:
			msg += _T ("DDERR_NOCLIPLIST\n");
			break;
		case DDERR_NOCOOPERATIVELEVELSET:
			msg += _T ("DDERR_NOCOOPERATIVELEVELSET\n");
			break;
		case DDERR_NODIRECTDRAWHW:
			msg += _T ("DDERR_NODIRECTDRAWHW\n");
			break;
		case DDERR_NODDROPSHW:
			msg += _T ("DDERR_NODDROPSHW\n");
			break;
		case DDERR_NOEMULATION:
			msg += _T ("DDERR_NOEMULATION\n");
			break;
		case DDERR_NOEXCLUSIVEMODE:
			msg += _T ("DDERR_NOEXCLUSIVEMODE\n");
			break;
		case DDERR_NOFLIPHW:
			msg += _T ("DDERR_NOFLIPHW\n");
			break;
		case DDERR_NOMIPMAPHW:
			msg += _T ("DDERR_NOMIPMAPHW\n");
			break;
		case DDERR_NOMIRRORHW:
			msg += _T ("DDERR_NOMIRRORHW\n");
			break;
		case DDERR_NORASTEROPHW:
			msg += _T ("DDERR_NORASTEROPHW\n");
			break;
		case DDERR_NOROTATIONHW:
			msg += _T ("DDERR_NOROTATIONHW\n");
			break;
		case DDERR_NOSTRETCHHW:
			msg += _T ("DDERR_NOSTRETCHHW\n");
			break;
		case DDERR_NOZBUFFERHW:
			msg += _T ("DDERR_NOZBUFFERHW\n");
			break;
		case DDERR_OUTOFMEMORY:
			msg += _T ("DDERR_OUTOFMEMORY\n");
			break;
		case DDERR_OUTOFVIDEOMEMORY:
			msg += _T ("DDERR_OUTOFVIDEOMEMORY\n");
			break;
		case DDERR_PRIMARYSURFACEALREADYEXISTS:
			msg += _T ("DDERR_PRIMARYSURFACEALREADYEXISTS\n");
			break;
		case DDERR_SURFACEBUSY:
			msg += _T ("DDERR_SURFACEBUSY\n");
			break;
		case DDERR_SURFACELOST:
			msg += _T ("DDERR_SURFACELOST\n");
			break;
		case DDERR_UNSUPPORTED:
			msg += _T ("DDERR_UNSUPPORTED The function called is not supported at this time.\n");
			break;
		case DDERR_UNSUPPORTEDMODE:
			msg += _T ("DDERR_UNSUPPORTEDMODE\n");
			break;
		case DDERR_WRONGMODE:
			msg += _T ("DDERR_WRONGMODE\n");
			break;
		default:
			msg += _T ("UNKNOWN DIRECTDRAW ERROR\n");
			break;
	}
	TRACE0 (msg);
}


void debugDSReportErrorFn (LPCTSTR title, HRESULT ddrval, LPCTSTR file, DWORD line)
{
	CString msg;
	msg.Format (_T("%s(%lu) : %s = "), file, line, title);
	switch (ddrval)
	{
		case DS_OK:
			msg += _T ("DD_OK The request completed successfully.\n");
			break; 
		case DSERR_ALLOCATED:
			msg += _T ("DSERR_ALLOCATED The request failed because resources, such as a priority level, were already in use by another caller.\n");
			break; 
		case DSERR_ALREADYINITIALIZED:
			msg += _T ("DSERR_ALREADYINITIALIZED The object is already initialized.\n");
			break; 
		case DSERR_BADFORMAT:
			msg += _T ("DSERR_BADFORMAT The specified wave format is not supported.\n");
			break; 
		case DSERR_BUFFERLOST:
			msg += _T ("DSERR_BUFFERLOST The buffer memory has been lost and must be restored.\n");
			break; 
		case DSERR_CONTROLUNAVAIL:
			msg += _T ("DSERR_CONTROLUNAVAIL The control (volume, pan, and so forth) requested by the caller is not available.\n");
			break; 
		case DSERR_GENERIC:
			msg += _T ("DSERR_GENERIC An undetermined error occurred inside the DirectSound subsystem.\n");
			break; 
		case DSERR_INVALIDCALL:
			msg += _T ("DSERR_INVALIDCALL This function is not valid for the current state of this object.\n");
			break; 
		case DSERR_INVALIDPARAM:
			msg += _T ("DSERR_INVALIDPARAM An invalid parameter was passed to the returning function.\n");
			break; 
		case DSERR_NOAGGREGATION:
			msg += _T ("DSERR_NOAGGREGATION The object does not support aggregation.\n");
			break; 
		case DSERR_NODRIVER:
			msg += _T ("DSERR_NODRIVER No sound driver is available for use.\n");
			break; 
		case DSERR_OTHERAPPHASPRIO:
			msg += _T ("DSERR_OTHERAPPHASPRIO This value is obsolete and is not used.\n");
			break; 
		case DSERR_OUTOFMEMORY:
			msg += _T ("DSERR_OUTOFMEMORY The DirectSound subsystem could not allocate sufficient memory to complete the caller's request.\n");
			break; 
		case DSERR_PRIOLEVELNEEDED:
			msg += _T ("DSERR_PRIOLEVELNEEDED The caller does not have the priority level required for the function to succeed.\n");
			break; 
		case DSERR_UNINITIALIZED:
			msg += _T ("DSERR_UNINITIALIZED The IDirectSound::Initialize method has not been called or has not been called successfully before other methods were called.\n");
			break; 
		case DSERR_UNSUPPORTED:
			msg += _T ("DSERR_UNSUPPORTED The function called is not supported at this time.\n");
			break; 
		default:
			msg += _T ("UNKNOWN DIRECTSOUND ERROR\n");
			break;
	}
	TRACE0 (msg);
}

#endif
