// KittyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Kitty.h"
#include "KittyDlg.h"
#include "AboutDialog.h"
#include "BitmapItem.h"
#include "RegistryStuff.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LPCTSTR szLink = _T("\\AniClock.lnk");
LPCTSTR szPersonMask = _T("p?*??.bmp");	// pNameXX.bmp
LPCTSTR szClockMask = _T("c?*.bmp");		// cName.bmp
const DWORD MAX_PERSONA = 100;

LPCTSTR lpszSection = _T("Settings");
LPCTSTR lpszEntryX = _T("X");
LPCTSTR lpszEntryY = _T("Y");
LPCTSTR lpszEntryPerson = _T("Person");
LPCTSTR lpszEntrySound = _T("Sound");

void SortStringList (CStringList &List)
{
	//  
	POSITION pos1 = List.GetHeadPosition ();
	while (pos1 != NULL) {
		POSITION pos1old = pos1;
		CString str1 = List.GetNext (pos1);
		POSITION pos2 = pos1;
		while (pos2 != NULL) {
			POSITION pos2old = pos2;
			CString str2 = List.GetNext (pos2);
			if (str1.CompareNoCase (str2) > 0) {
				List.SetAt (pos2old, str1);
				List.SetAt (pos1old, str2);
				str1 = str2;
			}
		}
	}
}

BOOL VerifyFile (LPCTSTR szFilename)
{
	WIN32_FIND_DATA FileData;	
	HANDLE hFile = FindFirstFile (szFilename, &FileData);
	if (hFile != INVALID_HANDLE_VALUE) {
		FindClose (hFile);
		return TRUE;
	}
	return FALSE;
}

void CreateLink (
	LPCTSTR lpszPathLink,		//  ,     (name.lnk)
	LPCTSTR lpszObjPath,		//     
	LPCTSTR lpszWorkDir,		//  
	LPCTSTR lpszIconPath,		//   
	int IconIndex)				//     
{ 
	CoInitialize (NULL);

	IShellLink* psl; 
	HRESULT hres = CoCreateInstance (CLSID_ShellLink, NULL, 
		CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID*) &psl); 
	if (SUCCEEDED (hres)) { 
		psl->SetPath (lpszObjPath); 
		psl->SetIconLocation (lpszIconPath, IconIndex);
		psl->SetWorkingDirectory (lpszWorkDir);

		IPersistFile* ppf;
		hres = psl->QueryInterface (IID_IPersistFile, (LPVOID*) &ppf); 
         if (SUCCEEDED (hres)) { 
			WORD wsz [MAX_PATH]; 
			MultiByteToWideChar (CP_ACP, 0, lpszPathLink, -1, wsz, MAX_PATH); 
			hres = ppf->Save (wsz, TRUE); 
			ppf->Release ();
        } 
        psl->Release (); 
    }

	CoUninitialize ();
}

CKittyDlg::CKittyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKittyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKittyDlg)
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon (IDR_MAINFRAME);
	ASSERT (m_hIcon);
	m_ClockSize = 150;
	m_hRgn = CreateEllipticRgn (0, 0, m_ClockSize, m_ClockSize);
	ASSERT (m_hRgn);
	m_eventStopped = ::CreateEvent (NULL, TRUE, TRUE, _T (""));	// 
	ASSERT (m_eventStopped);
	m_eventRequest = ::CreateEvent (NULL, TRUE, FALSE, _T (""));//  
	ASSERT (m_eventRequest);
	m_thread = NULL;}

void CKittyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKittyDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKittyDlg, CDialog)
	//{{AFX_MSG_MAP(CKittyDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_TIME, OnTime)
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_COMMAND(IDM_MOVE, OnMove)
	ON_COMMAND(IDM_ABOUT, OnAbout)
	ON_COMMAND(IDM_SOUND, OnSound)
	ON_COMMAND(IDM_AUTOSTART, OnAutostart)
	ON_BN_CLICKED (IDOK, OnOk)
	ON_BN_CLICKED (IDCANCEL, OnCancel)
	ON_WM_ERASEBKGND()
	ON_WM_NCRBUTTONDOWN()
	ON_WM_NCPAINT()
	ON_WM_NCLBUTTONDBLCLK()
	//}}AFX_MSG_MAP
	ON_WM_NCHITTEST ()
	ON_COMMAND_RANGE (IDM_SURF_1, IDM_SURF_10, OnSurf)
	ON_COMMAND_RANGE (IDM_PERSONA_1, IDM_PERSONA_1 + MAX_PERSONA, OnPersonSelect)
END_MESSAGE_MAP()

BOOL CKittyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//    
	m_bSound = GetProfileIntEx (lpszSection, lpszEntrySound, TRUE);
	int x = GetProfileIntEx (lpszSection, lpszEntryX, -1);
	if (x < 0 || x > GetSystemMetrics (SM_CXFULLSCREEN) - 10)
		x = GetSystemMetrics (SM_CXFULLSCREEN) - m_ClockSize - 4;
	int y = GetProfileIntEx (lpszSection, lpszEntryY, -1);
	if (y < 0 || y > GetSystemMetrics (SM_CYFULLSCREEN) - 10)
		y = 4;
	CString strPerson = GetProfileStringEx (lpszSection, lpszEntryPerson, _T(""));

	//   
	SetWindowRgn (m_hRgn, TRUE);
	SetWindowLong (GetSafeHwnd (), GWL_STYLE, WS_POPUP | WS_VISIBLE);
	SetWindowLong (GetSafeHwnd (), GWL_EXSTYLE, WS_EX_TOOLWINDOW);
	SetWindowPos (&wndTopMost, x, y, m_ClockSize, m_ClockSize, 0);

	SetIcon (m_hIcon, TRUE);	// Set big icon
	SetIcon (m_hIcon, FALSE);	// Set small icon

	CString strTitle;
	strTitle.LoadString (AFX_IDS_APP_TITLE);
	SetWindowText (strTitle);

	//  DirectDraw
	if (!m_Screen.Create (this)) {
		//   DirectDraw 
		EndDialog (0);
		AfxMessageBox (IDS_ERR_DIRECTDRAW, MB_ICONHAND | MB_OK);
		return FALSE;
	}

	//   
	LoadPersones ();

	//       
	POSITION pos = m_PersonList.GetHeadPosition ();
	while (pos != NULL) {
		CString strPath = m_PersonList.GetNext (pos);
		CString strTitle = strPath.Left (strPath.ReverseFind ('.') - 2);
		strTitle = strTitle.Mid (2 + strPath.ReverseFind ('\\'));
		if (!strTitle.CompareNoCase (strPerson)) {
			CString strNumber = strPath.Mid (strPath.ReverseFind ('.') - 2, 2);
			int number = strNumber [1] - '0' + 10 * (strNumber [0] - '0');
			m_Logo.LoadFile (m_Screen.GetDD2 (), strPath, 0, 0, number, strTitle);
			break;
		}
	}
	
	if (!m_Logo.IsLoaded ())
		//   
		if (!m_Logo.LoadResource (m_Screen.GetDD2 (), MAKEINTRESOURCE (IDB_LOGO), 0, 0, 2)) {
			//   
			EndDialog (0);
			AfxMessageBox (IDS_ERR_LOGO, MB_ICONHAND | MB_OK);
			return FALSE;
		}

	//  
	m_Logo.SetPos (
		(m_Screen.GetWidth () - m_Logo.GetWidth ()) / 2,
		(m_Screen.GetHeight () - m_Logo.GetHeight ()) / 2);

	//   
	if (!m_Clock.LoadResource (m_Screen.GetDD2 (), MAKEINTRESOURCE (IDB_CLOCK), 0, 0)) {
		//   
		EndDialog (0);
		AfxMessageBox (IDS_ERR_CLOCK, MB_ICONHAND | MB_OK);
		return FALSE;
	}

	//  
	m_Clock.SetPos (
		(m_Screen.GetWidth () - m_Clock.GetWidth ()) / 2,
		(m_Screen.GetHeight () - m_Clock.GetHeight ()) / 2);

	if (!m_Arrows.Create (m_Screen.GetDD2 (), 0, 0,
		m_Screen.GetWidth (), m_Screen.GetHeight ())) {
		//   
		EndDialog (0);
		AfxMessageBox (IDS_ERR_ARROWS, MB_ICONHAND | MB_OK);
		return FALSE;
	}

	//  
	m_HalfSound.Load (this, IDR_HALF);

	// Create the ToolTip control.
	m_tooltip.Create (this);
	m_tooltip.Activate (TRUE);
	m_tooltip.AddTool (this, _T(""));
	
	//    
	LPMALLOC g_pMalloc;
	LPITEMIDLIST pidlBrowse;
	m_strStartupFolder = _T("");
	if (SUCCEEDED (SHGetMalloc (&g_pMalloc))) {
		if (SUCCEEDED (SHGetSpecialFolderLocation
			(NULL, CSIDL_STARTUP, &pidlBrowse))) {	
			SHGetPathFromIDList (pidlBrowse, m_strStartupFolder.GetBuffer (MAX_PATH));				
			g_pMalloc->Free (pidlBrowse);
			m_strStartupFolder.ReleaseBuffer ();
		}
		g_pMalloc->Release (); 
	}

	Start ();

	return FALSE;
}

#pragma warning (disable:4100)
UINT CKittyDlg::OnNcHitTest (CPoint point)
{
	//    -  (..    )
	return HTCAPTION;
}
#pragma warning (default:4100)

void CKittyDlg::OnNcPaint ()
{
	//       ( Windows    !)
}

void CKittyDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc (this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc (), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics (SM_CXICON);
		int cyIcon = GetSystemMetrics (SM_CYICON);
		CRect rect;
		GetClientRect (&rect);
		int x = (rect.Width () - cxIcon + 1) / 2;
		int y = (rect.Height () - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon (x, y, m_hIcon);
	} else
		CDialog::OnPaint ();
}

#pragma warning (disable:4100)
BOOL CKittyDlg::OnEraseBkgnd (CDC* pDC) 
{
	//  
	return TRUE;
}
#pragma warning (default:4100)

HCURSOR CKittyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CKittyDlg::OnOk ()
{
	//  <ENTER>
}

void CKittyDlg::OnCancel ()
{
	WINDOWPLACEMENT wp;
	GetWindowPlacement (&wp);
	WriteProfileIntEx (lpszSection, lpszEntryX, wp.rcNormalPosition.left);
	WriteProfileIntEx (lpszSection, lpszEntryY, wp.rcNormalPosition.top);
	WriteProfileStringEx (lpszSection, lpszEntryPerson, m_Logo.GetName ());
	WriteProfileIntEx (lpszSection, lpszEntrySound, m_bSound);

	Stop ();

	if (m_eventStopped)
		CloseHandle (m_eventStopped);
	if (m_eventRequest)
		CloseHandle (m_eventRequest);
	if (m_thread)
		CloseHandle (m_thread);

	m_HalfSound.Destroy ();
	m_Arrows.Destroy ();
	m_Clock.Destroy ();
	m_Logo.Destroy ();
	m_Screen.Destroy ();

	CDialog::OnCancel ();
}

BOOL CKittyDlg::Start (void)
{
	if (m_eventStopped && m_eventRequest) {
		//    
		if (::WaitForSingleObject (m_eventStopped, 0) == WAIT_OBJECT_0) {
			if (m_thread)
				CloseHandle (m_thread);
			::ResetEvent (m_eventRequest);
			::ResetEvent (m_eventStopped);
			DWORD dwID;
			m_thread = ::CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) RunThread,
				this, 0, &dwID);
			ASSERT (m_thread);
			if (m_thread) {
				::SetThreadPriority (m_thread, THREAD_PRIORITY_ABOVE_NORMAL);
				return TRUE;
			}
		}
	}
	return FALSE;
}

BOOL CKittyDlg::Stop (void)
{
	if (m_eventStopped && m_eventRequest && m_thread) {
		::SetEvent (m_eventRequest);
		::WaitForSingleObject (m_thread, INFINITE);
		return TRUE;
	} else
		return FALSE;
}

UINT RunThread (LPVOID pParam)
{
	CKittyDlg* dlg = (CKittyDlg*) pParam;
	UINT result = 1;
	if (dlg)
		if (dlg->m_eventStopped && dlg->m_eventRequest) {
			result = dlg->Run ();
			::SetEvent (dlg->m_eventStopped);
		}
	::ExitThread (result);
	return result;
}

UINT CKittyDlg::Run (void)
{
	//   
	while (::WaitForSingleObject (m_eventRequest, 0) != WAIT_OBJECT_0) {
		m_Logo.NextFrame ();
		Draw ();
		Sleep (100);
	}
	return 0;
}

void CKittyDlg::Draw (void) 
{
	//   
	SYSTEMTIME st;
	GetLocalTime (&st);

	//      ToolTips
	static WORD wLastSecond = 60;
	if (st.wSecond != wLastSecond) {
		int datelen = GetDateFormat (LOCALE_USER_DEFAULT, DATE_LONGDATE, &st, NULL, NULL, 0);
		int timelen = GetTimeFormat (LOCALE_USER_DEFAULT, 0, &st, NULL, NULL, 0);
		CString strTimeDate;
		LPTSTR buf = strTimeDate.GetBuffer (datelen + timelen);
		GetDateFormat (LOCALE_USER_DEFAULT, DATE_LONGDATE, &st, NULL, buf, datelen);
		GetTimeFormat (LOCALE_USER_DEFAULT, 0, &st, NULL, buf + datelen, timelen);
		buf [datelen - 1] = ' ';
		strTimeDate.ReleaseBuffer (datelen + timelen);
		m_tooltip.UpdateTipText (strTimeDate, this);

		//     
		DrawClock (st.wHour, st.wMinute, st.wSecond);
	}
	wLastSecond = st.wSecond;

	//   
	static WORD wLastMinute = 60;
	if ((st.wMinute == 30 && wLastMinute == 29) ||
		(st.wMinute == 0 && wLastMinute == 59)) {
		if (m_bSound) {
			m_HalfSound.Rewind ();
			m_HalfSound.Play ();
		}
	}
	wLastMinute = st.wMinute;

	// 
	m_Clock.FastDraw (m_Screen.GetBS3 ());

	// 
	m_Logo.FastDraw (m_Screen.GetBS3 ());

	// 
	m_Arrows.FastDraw (m_Screen.GetBS3 ());

	//   
	m_Screen.Draw ();
}

void CKittyDlg::DrawClock (WORD hour, WORD minute, WORD second) 
{
	// 
	m_Arrows.GetImage ().Fill (RGB (255, 0, 255));

	const COLORREF HOUR_COLOR = RGB (0xff, 0xc0, 0xc0);
	const COLORREF MINUTE_COLOR = RGB (0xc0, 0xc0, 0xff);
	const COLORREF CIRCLE_COLOR = RGB (0xc0, 0xff, 0xc0);
	const double dPI = 3.14159265358979323846;
	const double d2PI = 2.0 * dPI;
	const double dPI2 = dPI / 2.0;

	//  
	int x = m_ClockSize / 2;
	int y = m_ClockSize / 2;
	
	//  
	double dSecondSize = (m_ClockSize - 20) / 2;
	double dMinuteSize = dSecondSize * 0.8;
	double dHourSize = dSecondSize * 0.5;

	//   
	double dHourAngle = dPI2 - ((double) (hour % 12) +
		(double) minute / 60.0) * d2PI / 12.0;
	double dMinuteAngle = dPI2 - ((double) minute +
		(double) second / 60.0) * d2PI / 60.0;
	double dSecondAngle = dPI2 - (double) second * d2PI / 60.0;

	//   
	POINT PolyHour [4];
	double rxHour = dHourSize * cos (dHourAngle);
	double ryHour = dHourSize * sin (dHourAngle);
	PolyHour [0].x = (int) (x + rxHour);
	PolyHour [0].y = (int) (y - ryHour);
	PolyHour [1].x = (int) (x + ryHour * 0.2);
	PolyHour [1].y = (int) (y + rxHour * 0.2);
	PolyHour [2].x = (int) (x - rxHour * 0.25);
	PolyHour [2].y = (int) (y + ryHour * 0.25);
	PolyHour [3].x = (int) (x - ryHour * 0.2);
	PolyHour [3].y = (int) (y - rxHour * 0.2);

	//   
	POINT PolyMinute [4];
	double rxMinute = dMinuteSize * cos (dMinuteAngle);
	double ryMinute = dMinuteSize * sin (dMinuteAngle);
	PolyMinute [0].x = (int) (x + rxMinute);
	PolyMinute [0].y = (int) (y - ryMinute);
	PolyMinute [1].x = (int) (x + ryMinute * 0.075);
	PolyMinute [1].y = (int) (y + rxMinute * 0.075);
	PolyMinute [2].x = (int) (x - rxMinute * 0.175);
	PolyMinute [2].y = (int) (y + ryMinute * 0.175);
	PolyMinute [3].x = (int) (x - ryMinute * 0.075);
	PolyMinute [3].y = (int) (y - rxMinute * 0.075);

	//   
	int rxSecond = (int) (dSecondSize * cos (dSecondAngle));
	int rySecond = (int) (dSecondSize * sin (dSecondAngle));

	HBRUSH hHourBrsh = CreateSolidBrush (HOUR_COLOR);
	HBRUSH hCircleBrsh = CreateSolidBrush (CIRCLE_COLOR);
	HBRUSH hMinuteBrsh = CreateSolidBrush (MINUTE_COLOR);

	//   ( GDI)
	HDC hDC = m_Arrows.GetImage ().GetDC ();
	if (hDC == NULL)
		return;

	SelectObject (hDC, GetStockObject (BLACK_PEN));
	SelectObject (hDC, hHourBrsh);
	Polygon (hDC, PolyHour, 4);
	SelectObject (hDC, hMinuteBrsh);
	Polygon (hDC, PolyMinute, 4);
	MoveToEx (hDC, x, y, NULL);
	LineTo (hDC, x + rxSecond, y - rySecond);
	SelectObject (hDC, hCircleBrsh);
	Ellipse (hDC, x - 3, y - 3, x + 3, y + 3);
	
	SelectObject (hDC, GetStockObject (LTGRAY_BRUSH));
	m_Arrows.GetImage ().ReleaseDC (hDC);

	DeleteObject (hMinuteBrsh);
	DeleteObject (hCircleBrsh);
	DeleteObject (hHourBrsh);
}

#pragma warning (disable:4100)
void CKittyDlg::OnNcRButtonDown (UINT nFlags, CPoint point) 
{
	CBitmapItem* PersonItem = NULL;

	try {
		//  
		CMenu Menu;
		Menu.LoadMenu (IDR_MENU);
		CMenu* PopupMenu = Menu.GetSubMenu (0);

		//   -  
		SetMenuDefaultItem (PopupMenu->GetSafeHmenu (), IDM_TIME, FALSE);

		//   
		CBitmapItem TimeItem, AboutItem, SurfPopup, PersonPopup,
			AutostartItem, MoveItem, CloseItem, SoundItem, SurfItem [10];
		TimeItem.Create (PopupMenu, IDM_TIME, IDB_TIME, 200);
		AboutItem.Create (PopupMenu, IDM_ABOUT, IDB_ABOUT, 200);
		const int SurfNum = 3;
		SurfPopup.Create (PopupMenu, SurfNum, IDB_SURF, 200, 0, NULL, MF_BYPOSITION);
		const int PersonNum = 5;
		PersonPopup.Create (PopupMenu, PersonNum, IDB_PERSONA, 200, 0,
			NULL, MF_BYPOSITION);
		SoundItem.Create (PopupMenu, IDM_SOUND, IDB_SOUND, 200,
			0, NULL, MF_BYCOMMAND, m_bSound);
		AutostartItem.Create (PopupMenu, IDM_AUTOSTART, IDB_AUTOSTART, 200,
			0, NULL, MF_BYCOMMAND, VerifyFile (m_strStartupFolder + szLink));
		MoveItem.Create (PopupMenu, IDM_MOVE, IDB_MOVE, 200);
		CloseItem.Create (PopupMenu, IDM_EXIT, IDB_CLOSE, 200);

		//   " "
		CMenu* SurfSubMenu = PopupMenu->GetSubMenu (SurfNum);
		for (DWORD i = 0; i < 10; i++) {
			//     ";"     
			CString Text;
			Text.LoadString (IDS_SURF_1 + i);
			int n = Text.Find (_T(";"));
			if (n >= 1) {
				SurfItem [i].Create (PopupMenu, IDM_SURF_1 + i, IDB_SURF,
					250, 0, Text.Left (n));
			} else {
				//  
				SurfSubMenu->RemoveMenu (IDM_SURF_1 + i, MF_BYCOMMAND);
			}
		}

		//    " " -  
		CMenu* PersonSubMenu = PopupMenu->GetSubMenu (PersonNum);
		CBitmapItem PersonDefaultItem;
		PersonDefaultItem.Create (PopupMenu, IDM_PERSONA_1, IDB_PERSONA, 250,
			0, NULL, MF_BYCOMMAND, !m_Logo.GetName ().GetLength ());
 
		//  -   " "
		LoadPersones ();

		//   " "
		if (!m_PersonList.IsEmpty ()) {
			PersonItem = new CBitmapItem [m_PersonList.GetCount ()];
			POSITION pos = m_PersonList.GetHeadPosition ();
			for (DWORD count = 0; pos != NULL; count++) {
				CString strTitle = m_PersonList.GetNext (pos);
				strTitle = strTitle.Left (strTitle.ReverseFind ('.') - 2);
				strTitle = strTitle.Mid (2 + strTitle.ReverseFind ('\\'));
				PersonSubMenu->AppendMenu (MF_STRING, IDM_PERSONA_1 + count + 1, strTitle);
				PersonItem [count].Create (PopupMenu, IDM_PERSONA_1 + count + 1,
					IDB_PERSONA, 250, 0, NULL, MF_BYCOMMAND,
					!strTitle.CompareNoCase (m_Logo.GetName ()));				
			}
		}

		//  
		PopupMenu->TrackPopupMenu (TPM_LEFTALIGN | TPM_LEFTBUTTON, point.x, point.y, this);

	} catch (...) {
		// ...
	}

	if (PersonItem != NULL)
		delete [] PersonItem;
}
#pragma warning (default:4100)

void CKittyDlg::LoadPersones (void)
{
	CFileFind ff;
	DWORD dwCount = 0;
	m_PersonList.RemoveAll ();
	BOOL next = TRUE;
	if (ff.FindFile (szPersonMask))
		while (next && dwCount < MAX_PERSONA) {
			next = ff.FindNextFile ();
			if (!ff.IsDirectory ()) {
				//  
				CString strNumber = ff.GetFileTitle ().Right (2);
				if (isdigit (strNumber [0]) && isdigit (strNumber [1]))
					if (strNumber [1] - '0' + 10 * (strNumber [0] - '0') > 0) {
						m_PersonList.AddTail (ff.GetFilePath ());
						dwCount++;
					}
			}
		}
		
	// 
	SortStringList (m_PersonList);
}

void CKittyDlg::OnExit() 
{
	//    -  close
	POINT pt;
	GetCursorPos (&pt);
	SendMessage (WM_SYSCOMMAND, SC_CLOSE, MAKEWORD (pt.x, pt.y));
}

void CKittyDlg::OnMove() 
{
	//    -  move
	POINT pt;
	GetCursorPos (&pt);
	SendMessage (WM_SYSCOMMAND, SC_MOVE, MAKEWORD (pt.x, pt.y));
}

void CKittyDlg::OnAbout() 
{
	CAboutDialog dlg;
	dlg.DoModal ();
}

void CKittyDlg::OnSurf (UINT nId)
{
	CString Text;
	Text.LoadString (IDS_SURF_1 + nId - IDM_SURF_1);
	int n = Text.Find (_T(";"));
	if (n >= 1)
		ShellExecute (NULL, NULL, Text.Mid (n + 1), NULL, _T(""), SW_SHOWNORMAL);
}

BOOL CKittyDlg::PreTranslateMessage(MSG* pMsg)
{
	m_tooltip.RelayEvent(pMsg);
	return CDialog::PreTranslateMessage(pMsg);	// CG: This was added by the ToolTips component.
}

void CKittyDlg::OnTime () 
{
	//      " /"
	CString strCommand, strParameters;
	strCommand.LoadString (IDS_CONTROL_COMMAND);
	strParameters.LoadString (IDS_CONTROL_PARAMS);
	ShellExecute (NULL, NULL, strCommand,  strParameters, _T(""), SW_SHOWNORMAL);
}

#pragma warning (disable:4100)
void CKittyDlg::OnNcLButtonDblClk (UINT nFlags, CPoint point)
{
	OnTime ();
}
#pragma warning (default:4100)

void CKittyDlg::OnSound () 
{
	m_bSound = !m_bSound;
}

void CKittyDlg::OnAutostart () 
{
	CString strPath (m_strStartupFolder + szLink);

	//   
	if (VerifyFile (strPath)) {
		//  
		DeleteFile (strPath);
		SHChangeNotify (SHCNE_DELETE , SHCNF_PATH, LPCTSTR (strPath), LPCTSTR (strPath));
	} else {
		//  
		CString strAppName;		
		strAppName = AfxGetApp ()->m_pszHelpFilePath;
		strAppName = strAppName.Left (strAppName.ReverseFind ('.'));
		strAppName += _T(".exe");
		
		CString strWorkDir;
		int n = strAppName.ReverseFind ('\\');
		if (n)
			strWorkDir = strAppName.Left (n);
		else {
			TCHAR szDir [MAX_PATH];
			GetCurrentDirectory (MAX_PATH, szDir);
			strWorkDir = szDir;
		}

		CreateLink (strPath, strAppName, strWorkDir, strAppName, 0);
		SHChangeNotify (SHCNE_CREATE, SHCNF_PATH, LPCTSTR (strPath), LPCTSTR (strPath));
	}
}

void CKittyDlg::OnPersonSelect (UINT nId) 
{
	Stop ();

	UINT index = nId - IDM_PERSONA_1;
	if (index == 0) {
		//   -
		if (!m_Logo.LoadResource (m_Screen.GetDD2 (), MAKEINTRESOURCE (IDB_LOGO), 0, 0, 2)) {
			//    -
			EndDialog (0);
			AfxMessageBox (IDS_ERR_LOGO, MB_ICONHAND | MB_OK);
			return;
		}
	} else {
		index--;
		if (index < MAX_PERSONA) {
			//    
			POSITION pos = m_PersonList.FindIndex (index);
			if (pos != NULL) {
				CString strPath = m_PersonList.GetAt (pos);
				CString strNumber = strPath.Mid (strPath.ReverseFind ('.') - 2, 2);
				int number = strNumber [1] - '0' + 10 * (strNumber [0] - '0');
				CString strTitle = strPath.Left (strPath.ReverseFind ('.') - 2);
				strTitle = strTitle.Mid (2 + strPath.ReverseFind ('\\'));
				
				if (!m_Logo.LoadFile (m_Screen.GetDD2 (), strPath, 0, 0, number, strTitle)) {
					//   
					AfxMessageBox (IDS_ERR_LOGO, MB_ICONHAND | MB_OK);
					
					//   -
					if (!m_Logo.LoadResource (m_Screen.GetDD2 (), MAKEINTRESOURCE (IDB_LOGO),
						0, 0, 2)) {
						//    - (, !)
						EndDialog (0);
						return;
					}
				}
			}
		}
	}

	// 
	m_Logo.SetPos (
		(m_Screen.GetWidth () - m_Logo.GetWidth ()) / 2,
		(m_Screen.GetHeight () - m_Logo.GetHeight ()) / 2);

	Start ();
}
